commit 48d323d75bbbd558f4845a91aa80c88cdb59736c
Author: jklowden <jklowden>
Date:   Mon Jul 28 20:58:19 2008 +0000

    tracking down SQLParamData behavior

diff --git a/ChangeLog b/ChangeLog
index b538776..3735d9d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Mon Jul 28 16:56:36 EDT 2008	JK Lowden <jklowden@freetds.org>
+	* samples/odbc_rpc.pl src/odbc/error.c src/odbc/odbc.c
+	- tracking down SQLParamData behavior 
+
 Thu Jul 24 18:02:52 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* samples/odbc_rpc.pl
 	* src/odbc/odbc.c src/odbc/prepare_query.c src/tds/net.c
@@ -474,4 +478,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2566 2008/07/24 22:04:49 jklowden Exp $
+$Id: ChangeLog,v 1.2567 2008/07/28 20:58:19 jklowden Exp $
diff --git a/samples/odbc_rpc.pl b/samples/odbc_rpc.pl
index 78b309e..9e4cf2c 100755
--- a/samples/odbc_rpc.pl
+++ b/samples/odbc_rpc.pl
@@ -1,5 +1,5 @@
 #!/usr/local/bin/perl
-# $Id: odbc_rpc.pl,v 1.8 2008/07/24 22:04:49 jklowden Exp $
+# $Id: odbc_rpc.pl,v 1.9 2008/07/28 20:58:19 jklowden Exp $
 #
 # Contributed by James K. Lowden and is hereby placed in 
 # the public domain.  No rights reserved.  
@@ -42,7 +42,7 @@ sub setup_error_handler($)
 { my ($dbh) = @_;
 
 	$dbh->{odbc_err_handler} = \&err_handler;
-	$dbh->{odbc_async_exec} = 1;
+	#dbh->{odbc_async_exec} = 1;
 	print "odbc_async_exec is: $dbh->{odbc_async_exec}\n";
 }
 
@@ -68,7 +68,7 @@ die qq(Syntax: \t$program [-D dsn] [-U username] [-P password] procedure [arg1[,
 	if( $opts{h} || 0 == @ARGV );
 
 # Connect
-my $dbh = DBI->connect($dsn, $user, $pass, {RaiseError => 0, PrintError => 1, AutoCommit => 1})
+my $dbh = DBI->connect($dsn, $user, $pass, {RaiseError => 1, PrintError => 1, AutoCommit => 1})
 	or die "Unable for connect to $dsn $DBI::errstr";
 
 setup_error_handler($dbh);
@@ -115,7 +115,7 @@ for( my $i=1; $i < @ARGV; $i++ ) {
 		if $type == SQL_DATETIME;
     }
     printf VERBOSE qq(Binding parameter #%d (%s): "$data"\n), ($i+1), $typename;
-    $sth->bind_param( 1 + $i, $data, $type );
+    $sth->bind_param( 1 + $i, $data, $type ) or die $sth->errstr;
 }
 
 print STDOUT qq(\nExecuting: "$sth->{Statement}" with parameters '), 
diff --git a/src/odbc/error.c b/src/odbc/error.c
index bc844f1..29cb953 100644
--- a/src/odbc/error.c
+++ b/src/odbc/error.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: error.c,v 1.55 2008/07/23 20:20:37 jklowden Exp $");
+TDS_RCSID(var, "$Id: error.c,v 1.56 2008/07/28 20:58:19 jklowden Exp $");
 
 static void odbc_errs_pop(struct _sql_errors *errs);
 static const char *odbc_get_msg(const char *sqlstate);
@@ -608,9 +608,16 @@ SQLRETURN ODBC_API
 SQLGetDiagRec(SQLSMALLINT handleType, SQLHANDLE handle, SQLSMALLINT numRecord, SQLCHAR FAR * szSqlState,
 	      SQLINTEGER FAR * pfNativeError, SQLCHAR * szErrorMsg, SQLSMALLINT cbErrorMsgMax, SQLSMALLINT FAR * pcbErrorMsg)
 {
+	SQLRETURN ret;
+	
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetDiagRec(%d, %p, %d, %p, %p, %p, %d, %p)\n", 
 			handleType, handle, numRecord, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
-	return _SQLGetDiagRec(handleType, handle, numRecord, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
+	
+	ret =_SQLGetDiagRec(handleType, handle, numRecord, szSqlState, pfNativeError, szErrorMsg, cbErrorMsgMax, pcbErrorMsg);
+	
+	tdsdump_log(TDS_DBG_FUNC, "SQLGetDiagRec returning %d\n", ret);
+	
+	return ret;
 }
 
 
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index d86f3d9..d4d5e1d 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.487 2008/07/24 22:04:50 jklowden Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.488 2008/07/28 20:58:19 jklowden Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -154,6 +154,28 @@ static void odbc_ird_check(TDS_STMT * stmt);
  * Bah!
  */
 
+static char *
+odbc_prret(SQLRETURN ret)
+{
+	static char unknown[32];
+	
+	switch (ret) {
+	case SQL_NULL_DATA:		return "SQL_ERROR or SQL_NULL_DATA";
+	case SQL_DATA_AT_EXEC:		return "SQL_DATA_AT_EXEC or SQL_INVALID_HANDLE";
+	case SQL_SUCCESS:		return "SQL_SUCCESS";
+	case SQL_SUCCESS_WITH_INFO:	return "SQL_SUCCESS_WITH_INFO";
+#if ODBCVER >= 0x0300
+	case SQL_NO_DATA:		return "SQL_NO_DATA";
+#endif
+	case SQL_STILL_EXECUTING:	return "SQL_STILL_EXECUTING";
+	case SQL_NEED_DATA:		return "SQL_NEED_DATA";
+	}
+	
+	snprintf(unknown, sizeof(unknown), "unknown: %d", (int)ret);
+
+	return unknown;
+}
+
 static void
 odbc_col_setname(TDS_STMT * stmt, int colpos, const char *name)
 {
@@ -3293,26 +3315,32 @@ SQLExecute(SQLHSTMT hstmt)
 
 	INIT_HSTMT;
 
-	tdsdump_log(TDS_DBG_FUNC, "SQLExecute(%p)\n", 
-			hstmt);
+	tdsdump_log(TDS_DBG_FUNC, "SQLExecute(%p)\n", hstmt);
 
-	if (!stmt->prepared_query)
+	if (!stmt->prepared_query) {
 		/* TODO error report, only without DM ?? */
+		tdsdump_log(TDS_DBG_FUNC, "SQLExecute returns SQL_ERROR (not prepared)\n");
 		ODBC_RETURN(stmt, SQL_ERROR);
+	}
 
-	/* TODO rebuild should be done for every bingings change, not every time */
+	/* TODO rebuild should be done for every bindings change, not every time */
 	/* TODO free previous parameters */
 	/* build parameters list */
 	stmt->param_data_called = 0;
 	stmt->curr_param_row = 0;
-	res = start_parse_prepared_query(stmt, 1);
-	if (SQL_SUCCESS != res)
+	if ((res = start_parse_prepared_query(stmt, 1)) != SQL_SUCCESS) {
+		tdsdump_log(TDS_DBG_FUNC, "SQLExecute returns %s (start_parse_prepared_query failed)\n", odbc_prret(res));
 		ODBC_RETURN(stmt, res);
+	}
 
 	/* TODO test if two SQLPrepare on a statement */
 	/* TODO test unprepare on statement free or connection close */
 
-	return _SQLExecute(stmt);
+	res = _SQLExecute(stmt);
+
+	tdsdump_log(TDS_DBG_FUNC, "SQLExecute returns %s\n", odbc_prret(res));
+
+	return res;
 }
 
 static int
@@ -5922,8 +5950,8 @@ SQLGetTypeInfo(SQLHSTMT hstmt, SQLSMALLINT fSqlType)
 	ODBC_RETURN(stmt, res);
 }
 
-SQLRETURN ODBC_API
-SQLParamData(SQLHSTMT hstmt, SQLPOINTER FAR * prgbValue)
+static SQLRETURN 
+_SQLParamData(SQLHSTMT hstmt, SQLPOINTER FAR * prgbValue)
 {
 	INIT_HSTMT;
 
@@ -5966,6 +5994,16 @@ SQLParamData(SQLHSTMT hstmt, SQLPOINTER FAR * prgbValue)
 }
 
 SQLRETURN ODBC_API
+SQLParamData(SQLHSTMT hstmt, SQLPOINTER FAR * prgbValue)
+{
+	SQLRETURN ret = _SQLParamData(hstmt, prgbValue);
+	
+	tdsdump_log(TDS_DBG_FUNC, "SQLParamData returns %s\n", odbc_prret(ret));
+	
+	return ret;
+}
+
+SQLRETURN ODBC_API
 SQLPutData(SQLHSTMT hstmt, SQLPOINTER rgbValue, SQLLEN cbValue)
 {
 	INIT_HSTMT;
@@ -5973,13 +6011,18 @@ SQLPutData(SQLHSTMT hstmt, SQLPOINTER rgbValue, SQLLEN cbValue)
 	tdsdump_log(TDS_DBG_FUNC, "SQLPutData(%p, %p, %i)\n", hstmt, rgbValue, (int)cbValue);
 
 	if (stmt->prepared_query || stmt->prepared_query_is_rpc) {
+		SQLRETURN ret;
+		const TDSCOLUMN *curcol = stmt->params->columns[stmt->param_num - (stmt->prepared_query_is_func ? 2 : 1)];
 		/* TODO do some more tests before setting this flag */
-		stmt->param_data_called = 1;
-		ODBC_RETURN(stmt, continue_parse_prepared_query(stmt, rgbValue, cbValue));
+		stmt->param_data_called = curcol->column_size == curcol->column_cur_size;
+		ret = continue_parse_prepared_query(stmt, rgbValue, cbValue);
+		tdsdump_log(TDS_DBG_FUNC, "SQLPutData returns %s, %d bytes left\n", 
+					  odbc_prret(ret), curcol->column_size - curcol->column_cur_size);
+		ODBC_RETURN(stmt, ret);
 	}
 
-	/* TODO return correct error */
-	tdsdump_log(TDS_DBG_FUNC, "SQLPutData: returning SQL_ERROR\n");
+	odbc_errs_add(&stmt->errs, "HY010", NULL);
+	tdsdump_log(TDS_DBG_FUNC, "SQLPutData returns SQL_ERROR (function sequence error)\n");
 	ODBC_RETURN(stmt, SQL_ERROR);
 }
 

